crypton-1.0.1: Cryptography Primitives sink

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | unknown
Safe Haskell | None
Language | Haskell2010

Crypto.PubKey.Ed25519

Contents

- Size constants
- Smart constructors
- Methods

Description

Ed25519 support

Synopsis

- data SecretKey
- data PublicKey
- data Signature
- publicKeySize :: Int
- secretKeySize :: Int
- signatureSize :: Int
- signature :: ByteArrayAccess ba => ba -> CryptoFailable Signature
- publicKey :: ByteArrayAccess ba => ba -> CryptoFailable PublicKey
- secretKey :: ByteArrayAccess ba => ba -> CryptoFailable SecretKey
- toPublic :: SecretKey -> PublicKey
- sign :: ByteArrayAccess ba => SecretKey -> PublicKey -> ba -> Signature
- verify :: ByteArrayAccess ba => PublicKey -> ba -> Signature -> Bool
- generateSecretKey :: MonadRandom m => m SecretKey

# Documentation

data SecretKey #

An Ed25519 Secret key

#### Instances

Instances details

NFData SecretKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods rnf :: SecretKey -> () #
Show SecretKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods showsPrec :: Int -> SecretKey -> ShowS # show :: SecretKey -> String # showList :: [SecretKey] -> ShowS #
Eq SecretKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods (==) :: SecretKey -> SecretKey -> Bool # (/=) :: SecretKey -> SecretKey -> Bool #
ByteArrayAccess SecretKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods length :: SecretKey -> Int # withByteArray :: SecretKey -> (Ptr p -> IO a) -> IO a # copyByteArrayToPtr :: SecretKey -> Ptr p -> IO () #

data PublicKey #

An Ed25519 public key

#### Instances

Instances details

NFData PublicKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods rnf :: PublicKey -> () #
Show PublicKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods showsPrec :: Int -> PublicKey -> ShowS # show :: PublicKey -> String # showList :: [PublicKey] -> ShowS #
Eq PublicKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods (==) :: PublicKey -> PublicKey -> Bool # (/=) :: PublicKey -> PublicKey -> Bool #
ByteArrayAccess PublicKey # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods length :: PublicKey -> Int # withByteArray :: PublicKey -> (Ptr p -> IO a) -> IO a # copyByteArrayToPtr :: PublicKey -> Ptr p -> IO () #

data Signature #

An Ed25519 signature

#### Instances

Instances details

NFData Signature # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods rnf :: Signature -> () #
Show Signature # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods showsPrec :: Int -> Signature -> ShowS # show :: Signature -> String # showList :: [Signature] -> ShowS #
Eq Signature # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods (==) :: Signature -> Signature -> Bool # (/=) :: Signature -> Signature -> Bool #
ByteArrayAccess Signature # |
Instance details Defined in Crypto.PubKey.Ed25519 Methods length :: Signature -> Int # withByteArray :: Signature -> (Ptr p -> IO a) -> IO a # copyByteArrayToPtr :: Signature -> Ptr p -> IO () #

# Size constants

publicKeySize :: Int #

A public key is 32 bytes

secretKeySize :: Int #

A secret key is 32 bytes

signatureSize :: Int #

A signature is 64 bytes

# Smart constructors

signature :: ByteArrayAccess ba => ba -> CryptoFailable Signature #

Try to build a signature from a bytearray

publicKey :: ByteArrayAccess ba => ba -> CryptoFailable PublicKey #

Try to build a public key from a bytearray

secretKey :: ByteArrayAccess ba => ba -> CryptoFailable SecretKey #

Try to build a secret key from a bytearray

# Methods

toPublic :: SecretKey -> PublicKey #

Create a public key from a secret key

sign :: ByteArrayAccess ba => SecretKey -> PublicKey -> ba -> Signature #

Sign a message using the key pair

verify :: ByteArrayAccess ba => PublicKey -> ba -> Signature -> Bool #

Verify a message

generateSecretKey :: MonadRandom m => m SecretKey #

Generate a secret key